'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _sourceMapSupport2 = require('source-map-support');

var _webdriver = require('webdriver');

var _wdioConfig = require('wdio-config');

var _utils = require('../../utils');

var _middlewares = require('../../middlewares');

var _constants = require('../../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)(); /**
                                    * The `$` command is a short way to call the [`element`](/api/protocol/element.html) command in order
                                    * to fetch a single element on the page. It returns an object that with an extended prototype to call
                                    * action commands without passing in a selector. However if you still pass in a selector it will look
                                    * for that element first and call the action on that element.
                                    *
                                    * Using the wdio testrunner this command is a global variable else it will be located on the browser object instead.
                                    *
                                    * You can chain `$` or `$$` together in order to walk down the DOM tree.
                                    *
                                    * <example>
                                       :index.html
                                       <ul id="menu">
                                           <li><a href="/">Home</a></li>
                                           <li><a href="/">Developer Guide</a></li>
                                           <li><a href="/">API</a></li>
                                           <li><a href="/">Contribute</a></li>
                                       </ul>
                                       :$.js
                                       it('should get text a menu link', function () {
                                           var text = $('#menu');
                                           console.log(text.$$('li')[2].$('a').getText()); // outputs: "API"
                                           // same as
                                           console.log(text.$$('li')[2].getText('a'));
                                       });
                                    * </example>
                                    *
                                    * @alias $
                                    * @param {String} selector  selector to fetch a certain element
                                    * @type utility
                                    *
                                    */

exports.default = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(selector) {
        var _this = this;

        var _findStrategy, using, value, res, prototype, element;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _findStrategy = (0, _utils.findStrategy)(selector, this.isW3C), using = _findStrategy.using, value = _findStrategy.value;
                        _context.next = 3;
                        return this.findElement(using, value);

                    case 3:
                        res = _context.sent;
                        prototype = (0, _assign2.default)((0, _webdriver.getPrototype)(this.isW3C), (0, _utils.getPrototype)('element'), { scope: 'element' });
                        element = (0, _webdriver.webdriverMonad)(this.options, function (client) {
                            var elementId = (0, _utils.getElementFromResponse)(res);

                            if (elementId) {
                                /**
                                 * set elementId for easy access
                                 */
                                client.elementId = elementId;

                                /**
                                 * set element id with proper key so element can be passed into execute commands
                                 */
                                if (_this.isW3C) {
                                    client[_constants.ELEMENT_KEY] = elementId;
                                } else {
                                    client.ELEMENT = elementId;
                                }
                            } else {
                                client.error = res;
                            }

                            client.selector = selector;
                            client.parent = _this;
                            client.emit = _this.emit.bind(_this);
                            return client;
                        }, prototype);
                        return _context.abrupt('return', element(this.sessionId, (0, _middlewares.elementErrorHandler)(_wdioConfig.wrapCommand)));

                    case 7:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    function $(_x) {
        return _ref.apply(this, arguments);
    }

    return $;
}();

module.exports = exports['default'];