'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _sourceMapSupport2 = require('source-map-support');

exports.default = deleteCookies;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();
function deleteCookies(names) {
    var _this = this;

    var namesList = typeof names !== 'undefined' && !Array.isArray(names) ? [names] : names;

    if (typeof namesList === 'undefined') {
        return this.deleteAllCookies();
    }

    if (namesList.every(function (obj) {
        return typeof obj !== 'string';
    })) {
        return _promise2.default.reject(new Error('Invalid input (see http://webdriver.io/api/cookie/deleteCookies.html for documentation.'));
    }

    return _promise2.default.all(namesList.map(function (name) {
        return _this.deleteCookie(name);
    }));
}
module.exports = exports['default'];