'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _sourceMapSupport2 = require('source-map-support');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();

/**
 *
 * Switch focus to a particular tab / window.
 *
 * @param {String|RegExp}  urlOrTitleToMatch  String or regular expression that matches the title or url of the page
 *
 * @uses protocol/getWindowHandles, protocol/switchToWindow, protocol/getCurrentUrl, protocol/getTitle
 * @alias browser.switchTab
 * @type window
 *
 */

exports.default = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(urlOrTitleToMatch) {
        var tabs, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, tab, url, title;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        if (!(typeof urlOrTitleToMatch !== 'string' && !(urlOrTitleToMatch instanceof RegExp))) {
                            _context.next = 2;
                            break;
                        }

                        throw new Error('Unsupported parameter for switchWindow, required is "string" or an RegExp');

                    case 2:
                        _context.next = 4;
                        return this.getWindowHandles();

                    case 4:
                        tabs = _context.sent;
                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        _context.prev = 8;
                        _iterator = (0, _getIterator3.default)(tabs);

                    case 10:
                        if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                            _context.next = 27;
                            break;
                        }

                        tab = _step.value;
                        _context.next = 14;
                        return this.switchToWindow(tab);

                    case 14:
                        _context.next = 16;
                        return this.getCurrentUrl();

                    case 16:
                        url = _context.sent;

                        if (!url.match(urlOrTitleToMatch)) {
                            _context.next = 19;
                            break;
                        }

                        return _context.abrupt('return', tab);

                    case 19:
                        _context.next = 21;
                        return this.getTitle();

                    case 21:
                        title = _context.sent;

                        if (!title.match(urlOrTitleToMatch)) {
                            _context.next = 24;
                            break;
                        }

                        return _context.abrupt('return', tab);

                    case 24:
                        _iteratorNormalCompletion = true;
                        _context.next = 10;
                        break;

                    case 27:
                        _context.next = 33;
                        break;

                    case 29:
                        _context.prev = 29;
                        _context.t0 = _context['catch'](8);
                        _didIteratorError = true;
                        _iteratorError = _context.t0;

                    case 33:
                        _context.prev = 33;
                        _context.prev = 34;

                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }

                    case 36:
                        _context.prev = 36;

                        if (!_didIteratorError) {
                            _context.next = 39;
                            break;
                        }

                        throw _iteratorError;

                    case 39:
                        return _context.finish(36);

                    case 40:
                        return _context.finish(33);

                    case 41:
                        throw new Error(`No window found with title or url matching "${urlOrTitleToMatch}"`);

                    case 42:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[8, 29, 33, 41], [34,, 36, 40]]);
    }));

    function switchWindow(_x) {
        return _ref.apply(this, arguments);
    }

    return switchWindow;
}();

module.exports = exports['default'];