'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _sourceMapSupport2 = require('source-map-support');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();

/**
 *
 * Double-click on an element.
 *
 * <example>
    :example.html
    <button id="myButton" ondblclick="document.getElementById('someText').innerHTML='I was dblclicked'">Click me</button>
    <div id="someText">I was not clicked</div>
    :doubleClick.js
    it('should demonstrate the doubleClick command', function () {
        var myButton = $('#myButton')
        myButton.doubleClick()
        // or
        browser.doubleClick('#myButton')
        var value = browser.getText('#someText')
        assert(value === 'I was dblclicked') // true
    })
 * </example>
 *
 * @alias browser.doubleClick
 * @param {String} selector  element to double click on. If it matches with more than one DOM-element it automatically clicks on the first element
 * @uses protocol/element, protocol/moveTo, protocol/doDoubleClick, protocol/touchDoubleClick
 * @type action
 *
 */
exports.default = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return this.moveTo();

                    case 2:
                        if (this.isW3C) {
                            _context.next = 4;
                            break;
                        }

                        return _context.abrupt('return', this.positionDoubleClick());

                    case 4:
                        _context.next = 6;
                        return this.performActions([{
                            type: 'pointer',
                            id: 'pointer1',
                            parameters: { pointerType: 'mouse' },
                            actions: [{ type: 'pointerDown', button: 0 }, { type: 'pointerUp', button: 0 }, { type: 'pause', duration: 10 }, { type: 'pointerDown', button: 0 }, { type: 'pointerUp', button: 0 }]
                        }]);

                    case 6:
                        return _context.abrupt('return', this.releaseActions());

                    case 7:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    function doubleClick() {
        return _ref.apply(this, arguments);
    }

    return doubleClick;
}();

module.exports = exports['default'];