'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _sourceMapSupport2 = require('source-map-support');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();

/**
 *
 * Determine an element’s location on the page. The point (0, 0) refers to
 * the upper-left corner of the page.
 *
 * <example>
    :getLocation.js
    it('should demonstrate the getLocation function', function () {
        browser.url('http://github.com');
        const logo = $('.octicon-mark-github')
        const location = logo.getLocation();
        console.log(location); // outputs: { x: 150, y: 20 }

        const xLocation = logo.getLocation('x')
        console.log(xLocation); // outputs: 150
        
        const yLocation = logo.getLocation('.octicon-mark-github', 'y')
        console.log(yLocation); // outputs: 20
    });
 * </example>
 *
 * @alias browser.getLocation
 * @param {String} property    can be "x" or "y" to get a result value directly for easier assertions
 * @return {Object|Number}  The X and Y coordinates for the element on the page (`{x:number, y:number}`)
 * @uses protocol/elementIdLocation
 * @type property
 */
exports.default = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(prop) {
        var location;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        location = {};

                        if (!this.isW3C) {
                            _context.next = 9;
                            break;
                        }

                        _context.next = 4;
                        return this.getElementRect(this.elementId);

                    case 4:
                        location = _context.sent;

                        delete location.width;
                        delete location.height;
                        _context.next = 12;
                        break;

                    case 9:
                        _context.next = 11;
                        return this.getElementLocation(this.elementId);

                    case 11:
                        location = _context.sent;

                    case 12:
                        if (!(prop === 'x' || prop === 'y')) {
                            _context.next = 14;
                            break;
                        }

                        return _context.abrupt('return', location[prop]);

                    case 14:
                        return _context.abrupt('return', location);

                    case 15:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    function getLocation(_x) {
        return _ref.apply(this, arguments);
    }

    return getLocation;
}();

module.exports = exports['default'];