'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sourceMapSupport2 = require('source-map-support');

exports.default = getProperty;

var _utils = require('../../utils');

var _getProperty = require('../../scripts/getProperty');

var _getProperty2 = _interopRequireDefault(_getProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)(); /**
                                    * The Get Element Property command will return the result of getting a property of an element.
                                    *
                                    * <example>
                                       :getProperty.js
                                       it('should demonstrate the getCssProperty command', function () {
                                           var elem = $('body')
                                           var color = elem.getProperty('tagName')
                                           console.log(color) // outputs: "BODY"
                                       })
                                    * </example>
                                    *
                                    * @alias browser.getProperty
                                    * @param {String} property  name of the element property
                                    */

function getProperty(property) {
    if (this.isW3C) {
        return this.getElementProperty(this.elementId, property);
    }

    return (0, _utils.getBrowserObject)(this).execute(_getProperty2.default, { ELEMENT: this.elementId }, property);
}
module.exports = exports['default'];