"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _sourceMapSupport2 = require("source-map-support");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();

/**
 *
 * Get the width and height for an DOM-element.
 *
 * <example>
    :getElementSize.js
    it('should demonstrate the getElementSize command', function () {
        browser.url('http://github.com')
        const logo = $('.octicon-mark-github')

        const size = logo.getElementSize()
        console.log(size) // outputs: { width: 32, height: 32 }

        const width = logo.getElementSize('width')
        console.log(width) // outputs: 32

        const height = logo.getElementSize('height')
        console.log(height) // outputs: 32
    })
 * </example>
 *
 * @alias browser.getElementSize
 * @param   {String*} prop     size to receive [optional] ("width" or "height")
 * @return {Object|Number}    requested element size (`{ width: <Number>, height: <Number> }`) or actual width/height as number if prop param is given
 * @uses protocol/elements, protocol/getElementRect
 * @type property
 *
 */

exports.default = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var prop = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
        var rect;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        rect = {};

                        if (!this.isW3C) {
                            _context.next = 7;
                            break;
                        }

                        _context.next = 4;
                        return this.getElementRect(this.elementId);

                    case 4:
                        rect = _context.sent;
                        _context.next = 10;
                        break;

                    case 7:
                        _context.next = 9;
                        return this.getElementSize(this.elementId);

                    case 9:
                        rect = _context.sent;

                    case 10:
                        if (!rect[prop]) {
                            _context.next = 12;
                            break;
                        }

                        return _context.abrupt("return", rect[prop]);

                    case 12:
                        return _context.abrupt("return", {
                            width: rect.width,
                            height: rect.height
                        });

                    case 13:
                    case "end":
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    function getElementSize() {
        return _ref.apply(this, arguments);
    }

    return getElementSize;
}();

module.exports = exports["default"];