"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sourceMapSupport2 = require("source-map-support");

exports.default = isSelected;
(0, _sourceMapSupport2.install)();
/**
 *
 * Will return true or false whether or not an `<option>` or `<input>` element of type
 * checkbox or radio is currently selected.
 *
 * <example>
    :index.html
    <select name="selectbox" id="selectbox">
        <option value="John Doe">John Doe</option>
        <option value="Layla Terry" selected="selected">Layla Terry</option>
        <option value="Bill Gilbert">Bill Gilbert"</option>
    </select>

    :isSelected.js
    it('should detect if an element is selected', function () {
        let element = $('[value="Layla Terry"]');
        console.log(element.isSelected()); // outputs: true

        element = $('[value="Bill Gilbert"]')
        console.log(element.isSelected()); // outputs: false
    });
 * </example>
 *
 * @alias browser.isSelected
 * @return {Boolean} true if element is selected
 * @uses protocol/elements, protocol/elementIdSelected
 * @type state
 *
 */

function isSelected() {
    return this.isElementSelected(this.elementId);
}
module.exports = exports["default"];