'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _sourceMapSupport2 = require('source-map-support');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();

/**
 *
 * Move the mouse by an offset of the specified element. If no element is specified,
 * the move is relative to the current mouse cursor. If an element is provided but
 * no offset, the mouse will be moved to the center of the element. If the element
 * is not visible, it will be scrolled into view.
 *
 * @param {Number} xoffset  X offset to move to, relative to the top-left corner of the element. If not specified, the mouse will move to the middle of the element.
 * @param {Number} yoffset  Y offset to move to, relative to the top-left corner of the element. If not specified, the mouse will move to the middle of the element.
 *
 * @see  https://github.com/SeleniumHQ/selenium/wiki/JsonWireProtocol#sessionsessionidmoveto
 * @type protocol
 */
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(xoffset, yoffset) {
    var _this = this;

    var _ref2, x, y, width, height, newXoffset, newYoffset;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (this.isW3C) {
              _context.next = 2;
              break;
            }

            return _context.abrupt('return', this.moveToElement(this.elementId, xoffset, yoffset));

          case 2:
            _context.next = 4;
            return this.getElementRect(this.elementId);

          case 4:
            _ref2 = _context.sent;
            x = _ref2.x;
            y = _ref2.y;
            width = _ref2.width;
            height = _ref2.height;
            newXoffset = parseInt(x + (typeof xoffset === 'number' ? xoffset : width / 2), 10);
            newYoffset = parseInt(y + (typeof yoffset === 'number' ? yoffset : height / 2), 10);

            /**
             * W3C way of handle the mouse move actions
             */

            return _context.abrupt('return', this.performActions([{
              type: 'pointer',
              id: 'finger1',
              parameters: { pointerType: 'mouse' },
              actions: [{ type: 'pointerMove', duration: 0, x: newXoffset, y: newYoffset }]
            }]).then(function () {
              return _this.releaseActions();
            }));

          case 12:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function moveTo(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return moveTo;
}();

module.exports = exports['default'];