"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sourceMapSupport2 = require("source-map-support");

exports.default = scrollIntoView;
(0, _sourceMapSupport2.install)();
/**
 *
 * Scroll element into viewport.
 *
 * <example>
    :scrollIntoView.js
    it('should demonstrate the scrollIntoView command', function () {
        const elem = $('#myElement');
        // scroll to specific element
        elem.scrollIntoView();
    });
 * </example>
 *
 * @alias browser.scrollIntoView
 * @uses protocol/execute
 * @type utility
 *
 */
function scrollIntoView() {
    return this.parent.execute( /* istanbul ignore next */function (elem) {
        return elem.scrollIntoView();
    }, {
        ELEMENT: this.elementId
    });
}
module.exports = exports["default"];