'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _sourceMapSupport2 = require('source-map-support');

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)(); /**
                                    *
                                    * Select option with a specific value.
                                    *
                                    * <example>
                                       :example.html
                                       <select id="selectbox">
                                           <option value="someValue0">uno</option>
                                           <option value="someValue1">dos</option>
                                           <option value="someValue2">tres</option>
                                           <option value="someValue3">cuatro</option>
                                           <option value="someValue4">cinco</option>
                                           <option name="someName5" value="someValue5">seis</option>
                                       </select>
                                       :selectByAttribute.js
                                       it('Should demonstrate the selectByAttribute command', function () {
                                           const selectBox = $('#selectbox');
                                           const value = selectBox.getValue();
                                           console.log(value); // returns "someValue0"
                                           selectBox.selectByAttribute('value', 'someValue3');
                                           console.log(selectBox.getValue()); // returns "someValue3"
                                           selectBox.selectByAttribute('name', 'someName5');
                                           console.log(selectBox.getValue()); // returns "someValue5"
                                       });
                                    * </example>
                                    *
                                    * @alias element.selectByAttribute
                                    * @param {String} attribute  attribute of option element to get selected
                                    * @param {String} value      value of option element to get selected
                                    * @uses protocol/findElementFromElement, protocol/elementClick
                                    * @type action
                                    *
                                    */

exports.default = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(attribute, value) {
        var normalized, optionElement;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        /**
                         * convert value into string
                         */
                        value = typeof value === 'number' ? value.toString() : value;

                        /**
                        * find option elememnt using xpath
                        */
                        normalized = `[normalize-space(@${attribute.trim()}) = "${value.trim()}"]`;
                        _context.next = 4;
                        return this.findElementFromElement(this.elementId, 'xpath', `./option${normalized}|./optgroup/option${normalized}`);

                    case 4:
                        optionElement = _context.sent;
                        return _context.abrupt('return', this.elementClick((0, _utils.getElementFromResponse)(optionElement)));

                    case 6:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    function selectByAttribute(_x, _x2) {
        return _ref.apply(this, arguments);
    }

    return selectByAttribute;
}();

module.exports = exports['default'];