'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _sourceMapSupport2 = require('source-map-support');

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)(); /**
                                    *
                                    * Select option with a specific index.
                                    *
                                    * <example>
                                       :example.html
                                       <select id="selectbox">
                                           <option value="someValue0">uno</option>
                                           <option value="someValue1">dos</option>
                                           <option value="someValue2">tres</option>
                                           <option value="someValue3">cuatro</option>
                                           <option value="someValue4">cinco</option>
                                           <option value="someValue5">seis</option>
                                       </select>
                                       :selectByIndex.js
                                       it('Should demonstrate the selectByIndex command', function () {
                                           const selectBox = $('#selectbox');
                                           console.log(selectBox.getValue()); // returns "someValue0"
                                           selectBox.selectByIndex(4);
                                           console.log(selectBox.getValue()); // returns "someValue4"
                                       });
                                    * </example>
                                    *
                                    * @alias element.selectByIndexs
                                    * @param {Number} index      option index
                                    * @uses protocol/findElementsFromElement, protocol/elementClick
                                    * @type action
                                    *
                                    */

exports.default = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(index) {
        var optionElements;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        if (!(index < 0)) {
                            _context.next = 2;
                            break;
                        }

                        throw new Error('Index needs to be 0 or any other positive number');

                    case 2:
                        _context.next = 4;
                        return this.findElementsFromElement(this.elementId, 'css', 'option');

                    case 4:
                        optionElements = _context.sent;

                        if (!(optionElements.length === 0)) {
                            _context.next = 7;
                            break;
                        }

                        throw new Error(`Select element doesn't contain any option element`);

                    case 7:
                        if (!(optionElements.length - 1 < index)) {
                            _context.next = 9;
                            break;
                        }

                        throw new Error(`Option with index "${index}" not found. Select element only contains ${optionElements.length} option elements`);

                    case 9:
                        return _context.abrupt('return', this.elementClick((0, _utils.getElementFromResponse)(optionElements[index])));

                    case 10:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    function selectByIndex(_x) {
        return _ref.apply(this, arguments);
    }

    return selectByIndex;
}();

module.exports = exports['default'];