'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _sourceMapSupport2 = require('source-map-support');

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)(); /**
                                    *
                                    * Select option with displayed text matching the argument.
                                    *
                                    * <example>
                                       :example.html
                                       <select id="selectbox">
                                           <option value="someValue0">uno</option>
                                           <option value="someValue1">dos</option>
                                           <option value="someValue2">tres</option>
                                           <option value="someValue3">cuatro</option>
                                           <option value="someValue4">cinco</option>
                                           <option value="someValue5">seis</option>
                                       </select>
                                       :selectByVisibleText.js
                                       it('demonstrate the selectByVisibleText command', function () {
                                           const selectBox = $('#selectbox');
                                           console.log(selectBox.getText('option:checked')); // returns "uno"
                                           selectBox.selectByVisibleText('cuatro');
                                           console.log(selectBox.getText('option:checked')); // returns "cuatro"
                                       })
                                    * </example>
                                    *
                                    * @alias element.selectByVisibleText
                                    * @param {String} text       text of option element to get selected
                                    * @uses protocol/findElementsFromElement, protocol/elementClick
                                    * @type action
                                    *
                                    */

exports.default = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(text) {
        var formatted, normalized, optionElement;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        /**
                         * convert value into string
                         */
                        text = typeof text === 'number' ? text.toString() : text;

                        /**
                        * find option element using xpath
                        */
                        formatted = /"/.test(text) ? 'concat("' + text.trim().split('"').join('", \'"\', "') + '")' : `"${text.trim()}"`;
                        normalized = `[normalize-space(translate(., ' ', '')) = ${formatted}]`;
                        _context.next = 5;
                        return this.findElementFromElement(this.elementId, 'xpath', `./option${normalized}|./optgroup/option${normalized}`);

                    case 5:
                        optionElement = _context.sent;
                        return _context.abrupt('return', this.elementClick((0, _utils.getElementFromResponse)(optionElement)));

                    case 7:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    function selectByVisibleText(_x) {
        return _ref.apply(this, arguments);
    }

    return selectByVisibleText;
}();

module.exports = exports['default'];