'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sourceMapSupport2 = require('source-map-support');

exports.default = getHTML;
(0, _sourceMapSupport2.install)();

/**
 * get HTML of selector element
 *
 * @param  {String}  selector            element to get HTML from
 * @param  {Boolean} includeSelectorTag  if true, selector tag gets included (uses outerHTML)
 * @return {String}                      html source
 */

function getHTML(element, includeSelectorTag) {
  return element[includeSelectorTag ? 'outerHTML' : 'innerHTML'];
}
module.exports = exports['default'];